/**********************************************************************
  ߎs ̂R
  $Id:$
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"
#include "op_exec.h"

int	op_exec3( struct MACHINE_RESOURCE *mres )
{
register unsigned int op2 ;
register unsigned int inst ;
unsigned int	bi,bo,lk ;
unsigned int	crbd,crba,crbb ;

 inst=mres->inst ;
 op2 = inst & 0x0000ffff ;
 if( (op2 & 0x0000fbfc)==0x00000020 ){ //bclr,bclrl,bcctr,bcctrl
   int	cc ;
   int	branch ;
   
   branch = NO ;
   lk  = inst & 0x00000001 ;
   bo  =(inst & 0x03e00000)<<6  ;
   bi  =(inst & 0x001f0000)>>16 ;
   cc  = mres->FLGR.cr[(bi/4)] & (0x80000000>>(bi%4)) ;
   switch( (bo & 0xf0000000) ){
   case 0x00000000 :
     if( op2==0x00000420 ) return(INVALID_BO) ;
     mres->FLGR.ctrl-- ;
     if( mres->FLGR.ctrl!=0 && cc==0 ) branch=YES ;
     break ;
   case 0x10000000 :
     if( op2==0x00000420 ) return(INVALID_BO) ;
     mres->FLGR.ctrl-- ;
     if( mres->FLGR.ctrl==0 && cc==0 ) branch=YES ;
     break ;
   case 0x20000000 :
     if( cc==0 ) branch=YES ;
     break ;
   case 0x40000000 :
     if( op2==0x00000420 ) return(INVALID_BO) ;
     mres->FLGR.ctrl-- ;
     if( mres->FLGR.ctrl!=0 && cc!=0 ) branch=YES ;
     break ;
   case 0x50000000 :
     if( op2==0x00000420 ) return(INVALID_BO) ;
     mres->FLGR.ctrl-- ;
     if( mres->FLGR.ctrl==0 && cc!=0 ) branch=YES ;
     break ;
   case 0x60000000 :
     if( cc!=0 ) branch=YES ;
     break ;
   case 0x80000000 :
     if( op2==0x00000420 ) return(INVALID_BO) ;
     mres->FLGR.ctrl-- ;
     if( mres->FLGR.ctrl!=0 ) branch=YES ;
     break ;
   case 0x90000000 :
     if( op2==0x00000420 ) return(INVALID_BO) ;
     mres->FLGR.ctrl-- ;
     if( mres->FLGR.ctrl==0 ) branch=YES ;
     break ;
   case 0xa0000000 :
     branch=YES ;
     break ;
   default :
     return(INVALID_BO) ;
   }
   if( branch==YES ){
     switch( op2 & 0x0000fffc ){
     case 0x00000020 : //bclr,bclrl
       //       printf("pc=%08x : ",mres->pc) ;
       if( lk!=0 ){
	 unsigned int next_lr ;
	 next_lr=mres->pc+4 ;
	 mres->pc=mres->FLGR.lrl ;
	 mres->FLGR.lrl=next_lr ;
       }else{
	 mres->pc=mres->FLGR.lrl ;
       }
       //       printf("ret_pc=%08x : ",mres->pc) ;
       //       printf("r3=%08x : ",mres->GPR[3].rl) ;
       //       printf("f1=%f\n"  ,mres->FPR[1].f ) ;
       break ;
     case 0x00000420 : //bcctr,bcctrl
       if( lk!=0 ){
	 mres->FLGR.lrl=mres->pc+4 ;
	 mres->pc=mres->FLGR.ctrl ;
       }else{
	 mres->pc=mres->FLGR.ctrl ;
       }
       break ;
     default : 
       return(UNKNOWN_INSTRUCTION) ;
     }
   }else{
     mres->pc += 4 ;
   }
   return(0) ;
 }
 
 if( (op2 & 0x0000003e)==0x00000002 ){ //crand,cror,crxor,crnand,crnor,creqv,crandc,crorc
   unsigned int a,d,b ;
   crbd=(inst & 0x03e00000)>>21 ;
   crba=(inst & 0x001f0000)>>16 ;
   crbb=(inst & 0x0000f800)>>11 ;
   
   a= ((mres->FLGR.cr[crba/4]>>28) & (0x00000008>>(crba%4)))>>(3-(crba%4)) ;
   b= ((mres->FLGR.cr[crbb/4]>>28) & (0x00000008>>(crbb%4)))>>(3-(crbb%4)) ;
   
   switch( op2 & 0x000007c0 ){
   case 0x00000200 : //crand
     d = a & b ;
     break ;
   case 0x000001c0 : //crnand
     d = ~(a & b) ;
     break ;
   case 0x00000380 : //cror
     d = a | b ;
     break ;
   case 0x00000040 : //crnor
     d = ~(a | b) ;
     break ;
   case 0x00000180 : //crxor
     d = a ^ b ;
     break ;
   case 0x00000240 : //crequ
     d = ~(a ^ b) ;
     break ;
   case 0x00000340 : //crorc
     d = a | ~b ;
     break ;
   case 0x00000100 : //crandc
     d = a & ~b ;
     break ;
   default :
     return(UNKNOWN_INSTRUCTION) ;
   }
   mres->FLGR.cr[crbd/4]=mres->FLGR.cr[crbd/4] & ~(0x80000000>>(crbd%4)) ; //Zbg
   mres->FLGR.cr[crbd/4]=mres->FLGR.cr[crbd/4] | ((d<<31)>>(crbd%4)) ;     //Zbg
   
   mres->pc += 4 ;
   return(0) ;
 }
 
 if( (op2 & 0x0000ffff)==0x00000064 ){ //rfi
   mres->pc   = *mres->SPR[26] & 0xfffffffc ; /** SRR0 **/
   *mres->MSR = (*mres->MSR & ~(0x0000ff73)) | (*mres->SPR[27] & 0x0000ff73) ; /** SRR1 **/
   return(0) ;
 }

 if( (op2 & 0x000007fe)==0x00000000 ){ //mcrf
   int	crfd,crfs ;
   crfd=(inst & 0x03800000)>>23 ;
   crfs=(inst & 0x001c0000)>>18 ;
   mres->FLGR.cr[crfd]=mres->FLGR.cr[crfs] ;
   mres->pc += 4 ;
   return(0) ;
 }
 if( (op2 & 0x000007ff)==0x0000012c ){ //isync
   mres->pc += 4 ; //肠NOP
   return(0) ;
 }
 
 return(UNKNOWN_INSTRUCTION) ;
}
