/**********************************************************************
  ߎs ̂S
  $Id:$
**********************************************************************/
#include <math.h>
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"
#include "op_exec.h"

int	op_exec4( struct MACHINE_RESOURCE *mres )
{
register unsigned int inst ;
unsigned int	fd,fa,fb,fc ;
unsigned int	rd ;

 inst=mres->inst ;

 fd=(inst & 0x03e00000)>>21 ;
 fa=(inst & 0x001f0000)>>16 ;
 fb=(inst & 0x0000f800)>>11 ;
 fc=(inst & 0x000007c0)>>6  ;
 rd=(inst & 0x00000001)     ;
 if( rd!=0 ) return(NOT_IMPLEMENTED_OP) ;
 
 if( (inst & 0x00000020)==0x00000020 ){
   switch( inst & 0x0000001e ){
     unsigned int *fpr_u ;
   case 0x00000004 : //fdivx
     mres->FPR[fd].f=mres->FPR[fa].f / mres->FPR[fb].f ;
     break ;
   case 0x00000008 : //fsubx
     mres->FPR[fd].f=mres->FPR[fa].f - mres->FPR[fb].f ;
     break ;
   case 0x0000000a : //faddx
     mres->FPR[fd].f=mres->FPR[fa].f + mres->FPR[fb].f ;
     break ;
   case 0x00000012 : //fmulx
     mres->FPR[fd].f=mres->FPR[fa].f * mres->FPR[fc].f ;
     break ;
   case 0x00000018 : //fmsubx
     mres->FPR[fd].f=(mres->FPR[fa].f * mres->FPR[fc].f) - mres->FPR[fb].f ;
     break ;
   case 0x0000001a : //fmaddx
     mres->FPR[fd].f=(mres->FPR[fa].f * mres->FPR[fc].f) + mres->FPR[fb].f ;
     break ;
   case 0x0000001c : //fnmsubx
     mres->FPR[fd].f=(mres->FPR[fa].f * mres->FPR[fc].f) - mres->FPR[fb].f ;
     fpr_u = (unsigned int *)&mres->FPR[fd].f ;
#ifdef HOST_ORDER_IS_LITTLE_ENDIAN
     fpr_u = fpr_u+1 ;
     *fpr_u= *fpr_u ^ 0x80000000 ;
#else
     *fpr_u= *fpr_u ^ 0x80000000 ;
#endif
     break ;
   case 0x0000001e : //fnmaddx
     mres->FPR[fd].f=(mres->FPR[fa].f * mres->FPR[fc].f) + mres->FPR[fb].f ;
     fpr_u = (unsigned int *)&mres->FPR[fd].f ;
#ifdef HOST_ORDER_IS_LITTLE_ENDIAN
     fpr_u = fpr_u+1 ;
     *fpr_u= *fpr_u ^ 0x80000000 ;
#else
     *fpr_u= *fpr_u ^ 0x80000000 ;
#endif
     break ;
   default :
     return(UNKNOWN_INSTRUCTION) ;
   }
   mres->pc += 4 ;
   return(0) ;
 }
 if( (inst & 0x00000020)==0x00000000 ){
   unsigned int cr ;
   int *cast_int, tmp_int ;
   if( (inst & 0x000007c0)==0x00000000){
     switch( inst & 0x0000001e ){
     case 0x00000000 : //fcmpu
       //FPSCR얢II
       cr= (inst & 0x03800000)>>23 ;
       update_crf(mres->FPR[fa].f,mres->FPR[fb].f,cr) ;
       break ;
     case 0x00000018 : //frspx
       mres->FPR[fd].f=(float)mres->FPR[fb].f ;
       break ;
       //case 0x0000001c : //fctiwx
       //break ;
     case 0x0000001e : //fctiwzx
       cast_int=(int *)&mres->FPR[fd].f ;
       tmp_int = (int)mres->FPR[fb].f ;
#ifdef HOST_ORDER_IS_LITTLE_ENDIAN
       *cast_int = tmp_int ;
       *(cast_int+1)=0 ;
#else
       *cast_int=0 ;
       *(cast_int+1)=tmp_int ;
#endif
       break ;
     default :
       return(UNKNOWN_INSTRUCTION) ;
     }
   }else{
     switch( inst & 0x000007fe ){
       unsigned int *fpr_u ;
     case 0x00000040 : // fcmpo
       //FPSCR얢II
       cr= (inst & 0x03800000)>>23 ;
       update_crf(mres->FPR[fa].f,mres->FPR[fb].f,cr) ;
       break ;
     case 0x00000050 : // fnegx
       mres->FPR[fd].f=mres->FPR[fb].f ;
       fpr_u = (unsigned int *)&mres->FPR[fd].f ;
#ifdef HOST_ORDER_IS_LITTLE_ENDIAN
       fpr_u = fpr_u+1 ;
       *fpr_u= *fpr_u ^ 0x80000000 ;
#else
       *fpr_u= *fpr_u ^ 0x80000000 ;
#endif
       break ;
     case 0x00000090 : // fmrx
       mres->FPR[fd].f=mres->FPR[fb].f ;
       break ;
     case 0x00000110 : // fnabsx
       mres->FPR[fd].f=mres->FPR[fb].f ;
       fpr_u = (unsigned int *)&mres->FPR[fd].f ;
#ifdef HOST_ORDER_IS_LITTLE_ENDIAN
       fpr_u = fpr_u+1 ;
       *fpr_u= *fpr_u | 0x80000000 ;
#else
       *fpr_u= *fpr_u | 0x80000000 ;
#endif
       break ;
     case 0x00000210 : // fabsx
       mres->FPR[fd].f=mres->FPR[fb].f ;
       fpr_u = (unsigned int *)&mres->FPR[fd].f ;
#ifdef HOST_ORDER_IS_LITTLE_ENDIAN
       fpr_u = fpr_u+1 ;
       *fpr_u= *fpr_u & 0x7fffffff ;
#else
       *fpr_u= *fpr_u & 0x7fffffff ;
#endif
       break ;
     default :
       return(UNKNOWN_INSTRUCTION) ;
     }
   }
   mres->pc += 4 ;
   return(0) ;
 }
 
 return(UNKNOWN_INSTRUCTION) ;
}
